<script setup>
import axios from "axios";
import { ref, onMounted } from "vue";
import { useRoute } from "vue-router";

const orders = ref([]);
const userId = ref(1);
const user = ref(null);
const route = useRoute();

const formatDate = (value) => {
  if (value) {
    const date = new Date(value);
    return date.toLocaleString();
  }
  return value;
};


const fetchOrderData = async () => {
    try {
        // Fetch the main order data based on the route parameter id
        const pesananResponse = await axios.get(
            `http://localhost:8000/api/pesanan/${route.params.id}`
        );
        const pesanan = pesananResponse.data;

        // Fetch the order details for the specific order
        const pesananDetailsResponse = await axios.get(
            `http://localhost:8000/api/pesanandetail/${pesanan.pesanan_id}`
        );
        const pesananDetailsList = pesananDetailsResponse.data;

        // Initialize books array in the pesanan object
        pesanan.books = [];

        // Fetch the details of each book and add it to the books array in the pesanan object
        for (let detail of pesananDetailsList) {
            const bukuId = detail.buku_id;

            const bukuResponse = await axios.get(
                `http://localhost:8000/api/buku/${bukuId}`
            );
            const buku = bukuResponse.data.bukus;

            pesanan.books.push({
                buku_id: bukuId,
                title: buku.title,
                quantity: detail.qty,
                price: buku.price,
            });
        }

        // Assign the populated pesanan object to the orders ref
        orders.value = pesanan;

    } catch (error) {
        console.error("Error fetching order data:", error);
    }
};

const getUserName = async () => {
    try {
        const userResponse = await axios.get(
            `http://localhost:8000/api/user/${userId.value}`
        );
        user.value = userResponse.data;
    } catch (error) {
        console.error("Error fetching user data:", error);
    }
};

onMounted(() => {
    fetchOrderData();
    getUserName();

    return{
        formatDate,
    }
});
</script>

<template>
    <div class="row justify-content-center" v-if="orders && user">
        <div style="height: 100px;"></div>
        <div class="col-8">
            <div class="row justify-content-center">
                <div class="col-lg-12 col-xl-7">
                    <div class="card">
                        <div class="card-body p-5">
                            <h2>INVOICE</h2>
                            <div class="border-top border-gray-200 pt-4 mt-4">
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="text-muted mb-2">Transaction ID</div>
                                        {{ orders.pesanan_id }}
                                    </div>
                                    <div class="col-md-6 text-md-end">
                                        <div class="text-muted mb-2">Payment Date</div>
                                        {{ formatDate(orders.updated_at) }}
                                    </div>
                                </div>
                            </div>
                            <div class="border-top border-gray-200 mt-4 py-4">
                                <div>
                                    <div class="text-muted mb-2">Client</div>

                                    <div class="row">
                                        <div class="col-md-6">
                                            {{ user.name }}
                                        </div>
                                        <div class="col-md-6 text-md-end">
                                            {{ user.email }}
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <table class="table border-bottom border-gray-200 mt-3">
                                <thead>
                                    <tr>
                                        <th scope="col" class="fs-sm text-dark text-uppercase-bold-sm px-0">
                                            Title
                                        </th>
                                        <th scope="col"
                                            class="fs-sm text-dark text-uppercase-bold-sm text-center align-middle">
                                            Qnty
                                        </th>
                                        <th scope="col" class="fs-sm text-dark text-uppercase-bold-sm text-end px-0">
                                            Amount
                                        </th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="(buku, index) in orders.books" :key="index">
                                        <td class="px-0 align-middle"> {{ buku.title }} </td>
                                        <td class="text-center align-middle"> {{ buku.quantity }}</td>
                                        <td class="text-end px-0 align-middle">{{ buku.price.toLocaleString("id-ID") }}</td>
                                    </tr>
                                    <tr>
                                        <td class="text-center align-middle" colspan="3"><strong>Happy Reading &lt;3</strong></td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div v-else class="text-center mt-5">Loading...</div>
</template>
